/* JS for employee services */

// init on page load

Event.observe(window, 'load', function() {
    es.init();
    //pgRegMgr.add_endRequest(BeginAsyncHandler);
});

// extra PUP functions
Element.addMethods({
    wrap: function(element, tagName) {
        element = $(element);
        var wrapper = document.createElement(tagName);
        element.parentNode.replaceChild(wrapper, element);
        wrapper.appendChild(element);
        return Element.extend(wrapper);
    },
    pad: function(element, tagName) {
        element.innerHTML = '<' + tagName + '>' + element.innerHTML + '</' + tagName + '>' ;
        return $(element).down(tagName);
    },
    setClassName: function(element, className) {
        element = $(element);
        if (Prototype.Browser.IE) {
            element.className = className;
        }
        else {
            element.setAttribute('class', className);
        }
        return Element.extend(element);
    }
});
var es = {
    init: function(element) {

        if (!$(element)) {
            element = $$('body')[0];
        }
        else {
            element = $(element);eyou
        }

        if (window.attachEvent) {
            if (navigator.appVersion.indexOf('MSIE 6.0')) {
                Prototype.BrowserVersion = 6;
            }
            else {
                Prototype.BrowserVersion = 7;
            }
        }
        if ($('underlay')) {
            $('underlay').observe('click', es.hideBubble);
            $('underlay').observe('click', es.PUHtmlSelectDeActivate);
        }
        es.initTabbedPanels(element);
        es.initTogglers(element);
        es.initPUHtmlSelectLists(element);
        es.initExternalLinks(element);
    },
    initTabbedPanels: function(element) {
        var PUTabs = element.getElementsBySelector('.PUTabbedPanel_tabs li');
        PUTabs.each(function(tab) {
            tab.observe('click', function() {
                var elm = $(this);
                var PUTabbedPanel = elm.up('.PUTabbedPanel');
                PUTabbedPanel.down('.PUTabbedPanel_tabs li.selected').removeClassName('selected');
                elm.addClassName('selected');
                PUTabbedPanel.down('.PUTabbedPanel_content li.selected').hide().removeClassName('selected');
                $(elm.id + '_content').show().addClassName('selected');
            });
        });
        var PUContents = $$('.PUTabbedPanel_content li');
        PUContents.each(function(content) {
            if (content.className != 'selected')
                content.hide();
        });
    },
    initTogglers: function(element) {
        var handles = element.select('.toggler .handle');
        handles.each(function(handle) {
            handle.observe('click', es.toggleCollapsible);
        });
    },
    initPUHtmlSelectLists: function(element) {

        lists = element.select('.PUHtmlSelectList');
        lists.each(function(list) {
            list.observe('click', es.PUHtmlSelectListToggle);
        });
    },
    initExternalLinks: function(element) {
        var links = element.select('.openLinksInNewWindow a');
        links.each(function(linky) {
            if (!linky.href.startsWith('mailto:'))
                linky.observe('click', function(event) { launchNewWindow(linky.href, 500, 900, ''); event.stop(event); });
        });
    },
    PUHtmlSelectListToggle: function(event) {
        var elm = Event.element(event).up('.PUHtmlSelectList');
        if (!elm.hasClassName('active')) {
            elm.addClassName('active');
            elm.setStyle({ 'zIndex': '12' });
            $('underlay').show();
        }
        else {
            elm.removeClassName('active');
            elm.setStyle({ 'zIndex': '5' });
            $('underlay').hide();
        }
    },
    PUHtmlSelectDeActivate: function(event) {
        lists = $$('.PUHtmlSelectList');
        lists.each(function(list) {
            if (list.hasClassName('active')) {
                list.removeClassName('active');
            }
            list.setStyle({ 'zIndex': '5' });
        });
    },
    toggleCollapsible: function() {
        var elm = $(this);
        var toggler = elm.up('.toggler');
        if (toggler) {
            var content = toggler.down('.toggler_content');
        }
        if (content) {
            if (content.visible()) {
                es.closeCollapsible(toggler);
            }
            else {
                es.openCollapsible(toggler);
            }
        }
    },
    toggleCollapsibles: function(elm) {
        var elm = $(elm);
        if (elm.hasClassName('all_collapsed')) {
            elm.removeClassName('all_collapsed');
            es.openCollapsibles(elm);
        }
        else {
            elm.addClassName('all_collapsed');
            es.closeCollapsibles(elm);
        }
    },
    closeCollapsible: function(elm) {
        var content = elm.down('.toggler_content');
        Effect.Fade(content, { duration: .25 });
        elm.addClassName('collapsed');
        var collapsedInput = elm.down('.toggler_collapsed');
        if (collapsedInput) {
            collapsedInput.value = 'true';
        }
    },
    openCollapsible: function(elm) {
        var content = elm.down('.toggler_content');
        Effect.Appear(content, { duration: .25 });
        elm.removeClassName('collapsed');
        var collapsedInput = elm.down('.toggler_collapsed');
        if (collapsedInput) {
            collapsedInput.value = 'false';
        }
    },
    openCollapsibles: function(elm) {
        var togglers = elm.select('.toggler');
        togglers.each(function(toggler) {
            es.openCollapsible(toggler);
        });
    },
    closeCollapsibles: function(elm) {
        var togglers = elm.select('.toggler');
        togglers.each(function(toggler) {
            es.closeCollapsible(toggler);
        });
    },
    hideBubble: function() {
        $('underlay').hide();
        $('bubble_popup').hide();
    },
    addCloseConfirmation: function(message) {
        Event.observe(window, 'beforeunload', function(e) {
            if (e.clientY < 0) {
                alert(message);
                return message;
            }
        });
    }
}

var nineBox = {
	yLength: 425,
	xLength: 737,
	points: null,
	employees: null,
	activePoint: null,
	activeEmployee: null,
	activeEmployeeID: null,
	init: function(config) {
		this.initAxis(config);
		this.points = config.points;
		this.employees = config.employees;
        switch (config.mode) {
            case 'teams':           //display icon and name, plotted at exact coordinates
                this.buildTeamNineBox();
				$('NineBoxQuadrants').hide();
                break;
            case 'cells':           //display current level employees only, shown as a list in each ninebox cell
                this.buildCellBasedNineBox();
				$('NineBoxPoints').hide();
                break;
			case 'organisation':     //display all descendants on single ninebox, icons only
                $(config.data).each(function(p) {
                    $('NineBoxPoints').insert('<div class="dot" style="left:' + p.x + 'px;bottom:' + p.y + 'px"></div>');
                });
				$('NineBoxQuadrants').hide();
                break;
            default: break;
        }
		this.enableDroppables();
    },
	initAxis: function(config) {
		var x = config.axis.x;
		var y = config.axis.y;
		nineBox.xLimit = x.limit;
		nineBox.yLimit = y.limit;
		nineBox.xAxisRatio = Number(nineBox.xLength / x.limit);
		nineBox.yAxisRatio = Number(nineBox.yLength / y.limit);
		nineBox.xSnap = nineBox.xLength / (x.limit*10);
		nineBox.ySnap = nineBox.yLength / (y.limit*10);
		$('xAxisLabel').update(x.label);
		$('yAxisLabel').update(y.label);
		
		var previous = 0;
		for (var scale in x.scales) {
			var value = (scale*nineBox.xAxisRatio);
			$('xAxisScales').insert('<li style="left:'+previous+'px; width:'+(value-previous)+'px"><span>'+x.scales[scale]+'</span></li>');
			previous = value;
		}
		previous = 0;
		for (var scale in y.scales) {
			var value = (scale*nineBox.yAxisRatio)
			$('yAxisScales').insert('<li style="bottom:'+previous+'px; height:'+(value-previous)+'px; line-height:'+(value-previous)+'px"><span><span>'+y.scales[scale]+'</span></span></li>');
			previous = value;
		}
		if (config.tenth) {
			$('q_10_label').update('<span>'+config.tenth.label+'</span>').show();
			$('q_10').show();
		}
	},
	toggleView: function() {
		nineBox.mode = (nineBox.mode == 'teams') ? 'cells' : 'teams';
		if ($('NineBoxQuadrants').visible()) {
			nineBox.buildTeamNineBox();
		}
		else {
			nineBox.buildCellBasedNineBox();
		}
		$('NineBoxPoints').toggle();
		$('NineBoxQuadrants').toggle();
	},
	buildTeamNineBox: function() {
		$('NineBoxPoints').update('');
		$('q_10').update('');
		for (var id in nineBox.employees) {
			var employee = nineBox.employees[id];
			var point = nineBox.points[id];
			var x = Math.floor(point.x * nineBox.xAxisRatio);
			var y = Math.floor(nineBox.yLength -(point.y * nineBox.yAxisRatio));
			/*
			if (x == 0 && y == nineBox.yLength) {
				// add to tenth
				$('q_10').insert('<li id="employee_'+id+'">' + employee.name + '</li>');
				return;
			}
			*/
			if (!$('point_'+x+'_'+y)) { 
				// if there isn't anyone at a point create new icon
				$('NineBoxPoints').insert('<div class="point ' + employee.cssClass + '" id="point_'+x+'_'+y+'" style="left:'+x+'px;top:'+y+'px"><div class="icon" onclick="mb();"></div><ul class="names"></ul></div>');
			}
			else {
				$('point_'+x+'_'+y).addClassName('multiple')
			}
			var names = $$('#point_'+x+'_'+y+' .names');
			if (names) {
				names[0].insert('<li id="employee_'+id+'">' + employee.name + '</li>');
			}
		}
		nineBox.enableDraggables();
	},
	buildCellBasedNineBox: function() {
		for (var x=0;x<3;x++) {
			for (var y=0;y<3;y++) {
				$('q_'+x+'_'+y).update('');
			}
		}
		for (var id in nineBox.employees) {
			var employee = nineBox.employees[id];
			var point = nineBox.points[id];
			var x = Math.floor((point.x*nineBox.xAxisRatio) / (nineBox.xLength/3));
			var y = Math.floor((point.y*nineBox.yAxisRatio) / (nineBox.yLength/3));
			x = x <= 0 ? 0 : x; x = (x > 2) ? 2 : x;
			y = y <= 0 ? 0 : y; y = (y > 2) ? 2 : y;
			$('q_'+x+'_'+y).insert('<li class="' + employee.cssClass + '"><div class="icon" onclick="showBubble(this);"></div><span>' + employee.name + '</span></li>');
		}
	},
	enableDraggables: function() {
		
		var draggableNames = $$('#NineBoxPoints .point.multiple .names li');
		var draggablePoints = $$('#NineBoxPoints .point:not(.multiple)');
		
		draggableNames.each(function(elm) {
			new Draggable(elm, {
				onStart: nineBox.initEmployeeDrag,
				onDrag: nineBox.dragEmployee,
				onEnd: nineBox.endDrag,
				snap: [nineBox.xSnap,nineBox.ySnap]
			});
		});
		draggablePoints.each(function(elm) {
			new Draggable(elm, {
				onStart: nineBox.initPointDrag,
				onDrag: nineBox.dragPoint,
				onEnd: nineBox.endDrag,
				snap: [nineBox.xSnap,nineBox.ySnap]
			});
		});
	},
	endDrag: function() {
		$('activeXValue').hide();
		$('activeYValue').hide();
		setTimeout(function() {
			nineBox.buildTeamNineBox();
		},20);
	},
	enableDroppables: function() {
		Droppables.add('q_10', {
			hoverclass: 'over',
			onDrop: nineBox.dropOnTenth
		});
	},
	dragEmployee: function() {
		var xRating = nineBox.getXRating(Number(nineBox.activePoint.style.left.replace('px','')) + Number(nineBox.activeEmployee.style.left.replace('px','')));
		var yRating = nineBox.getYRating(Number(nineBox.activePoint.style.top.replace('px','')) + Number(nineBox.activeEmployee.style.top.replace('px','')));
		nineBox.updateRatings(xRating,yRating);
	},
	dragPoint: function() {
		var xRating = nineBox.getXRating(nineBox.activePoint.style.left.replace('px',''));
		var yRating = nineBox.getYRating(nineBox.activePoint.style.top.replace('px',''));
		nineBox.updateRatings(xRating, yRating);
	},
	initEmployeeDrag: function(eventName, draggable) {
		var name = draggable.element();
		if (name) {
			var point = name.up('.point');
			if (point) {
				nineBox.updateActiveElement(point, name);
			}
		}
	},
	initPointDrag: function(eventName,draggable) {
		// getting the dragged element was proving difficult here, it's the element in front.
		var point = draggable.element();
		if (!point.hasClassName('point')) {
			point = point.up('.point');
		}
		if (point) {
			var name = point.down('.names li');
			if (name) {
				nineBox.updateActiveElement(point, name);
			}
		}
	},
	updateActiveElement: function(point, name) {
		nineBox.activePoint = point;
		nineBox.activeEmployee = name;
		nineBox.activeEmployeeID = name.id.replace('employee_','');
		$('activeXValue').show();
		$('activeYValue').show();
	},
	updateRatings: function(xRating,yRating) {
		var xPos = ((xRating/nineBox.xLimit)*100);
		var yPos = ((yRating/nineBox.yLimit)*100);
		nineBox.points[nineBox.activeEmployeeID].x = xRating;
		nineBox.points[nineBox.activeEmployeeID].y = yRating;
		$('activeXValue').style.left = xPos + '%';
		$('activeYValue').style.bottom = yPos + '%';
	},
	dropOnTenth: function(eventName,draggable) {
		nineBox.points[nineBox.activeEmployeeID].x = 0;
		nineBox.points[nineBox.activeEmployeeID].y = 0;
	},
	getXRating: function(xPos) {
		var x = Number(xPos/nineBox.xAxisRatio).toFixed(1);
		x = (x<0) ? 0 : x;
		x = (x>nineBox.xLimit) ? nineBox.xLimit : x;
		return x
	},
	getYRating: function(yPos) {
		var y = Number((nineBox.yLength-yPos)/nineBox.yAxisRatio).toFixed(1);
		y = (y<0) ? 0 : y;
		y = (y>nineBox.yLimit) ? nineBox.yLimit : y;
		return y;
	},
	save: function() {
		alert(Object.toJSON(nineBox.points));
	}
}